/*
 * GuiCompraPropiedad.java
 *
 * Created on 30 de diciembre de 2007, 21:47
 */

package interfaz;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import uhupoly.Casilla;
import uhupoly.Juego;
import uhupoly.Jugador;
import uhupoly.Propiedad;

/**
 *
 * @author  Pandre
 */
public class GuiCompraPropiedad extends javax.swing.JDialog {
    
    Propiedad casilla;
    Jugador jugador;
    Juego juego;
    
    java.awt.Frame frameTablero;
    
    /** Creates new form GuiCompraPropiedad */
    public GuiCompraPropiedad(java.awt.Frame parent, boolean modal, Casilla casilla, Jugador jugadorActual, Juego juego) {
        
        super(parent, modal);
        
        frameTablero = parent;
        
        this.casilla = ((Propiedad)casilla);
        this.juego = juego;
        this.jugador = jugadorActual;
        
        initComponents();
        
        jLabelPrecio.setText(this.casilla.getPrecio() + "");

        int angulo;
        int numCasilla = casilla.getIdCasilla();
        if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
        else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
        else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
        else angulo = 90;
        if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;
        
        jLabelIcono.setIcon(rotarImagen(casilla.getIdCasilla(), angulo));
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jButtonSubastar = new javax.swing.JButton();
        jButtonComprar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabelPrecio = new javax.swing.JLabel();
        jLabelIcono = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Adquirir propiedad");
        setModal(true);
        setResizable(false);
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("ADQUIRIR PROPIEDAD");

        jButtonSubastar.setText("Sacar a subasta");
        jButtonSubastar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSubastarActionPerformed(evt);
            }
        });

        jButtonComprar.setFont(new java.awt.Font("Tahoma", 1, 14));
        jButtonComprar.setText("Comprar");
        jButtonComprar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonComprarActionPerformed(evt);
            }
        });

        jLabel2.setText("Precio de la propiedad:");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabelPrecio.setFont(new java.awt.Font("Tahoma", 1, 24));
        jLabelPrecio.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecio.setText("160\u20ac");
        jLabelPrecio.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabelIcono.setIcon(new javax.swing.ImageIcon("res\\casilla12.png"));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(30, 30, 30)
                        .addComponent(jLabelIcono, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(35, 35, 35)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabelPrecio, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jButtonComprar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSubastar))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecio, javax.swing.GroupLayout.DEFAULT_SIZE, 78, Short.MAX_VALUE))
                    .addComponent(jLabelIcono, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(23, 23, 23)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonSubastar, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonComprar))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonSubastarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSubastarActionPerformed

        GuiSubastaPropiedad jdSubasta = new GuiSubastaPropiedad(frameTablero, true, casilla, juego);
        jdSubasta.setLocation(frameTablero.getWidth()/2-jdSubasta.getWidth()/2, 
            frameTablero.getHeight()/2-jdSubasta.getHeight()/2);
        this.setVisible(false);
        jdSubasta.setVisible(true);
        
    }//GEN-LAST:event_jButtonSubastarActionPerformed

    private void jButtonComprarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonComprarActionPerformed

        if (jugador.tieneEfectivo(casilla.getPrecio()))
        {
            jugador.setCapital(jugador.getCapital() - casilla.getPrecio());
            casilla.setPropietario(jugador);
            jugador.getPropiedades().add(casilla);
        }
        else
        {
        
            // Notifica q no tiene dinero
            JOptionPane.showMessageDialog(null, "No tienes suficiente dinero para comprar esta propiedad! \n\nLa propiedad saldr a subasta.\n", "No puedes comprar", JOptionPane.PLAIN_MESSAGE );
                                    
            // Muestra formulario de subasta
            jButtonSubastarActionPerformed(null);
        }
        
        this.setVisible(false);
        dispose();
        
    }//GEN-LAST:event_jButtonComprarActionPerformed
    
    
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButtonComprar;
    private javax.swing.JButton jButtonSubastar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelIcono;
    private javax.swing.JLabel jLabelPrecio;
    // Fin de declaracin de variables//GEN-END:variables
    
    /*
    * Funcin tomada y adaptada desde el ejemplo mostrado en:
    *   http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=2&t=013741
    */
    private ImageIcon rotarImagen(int numCasilla, int grados)
    {
        // Carga la imagen
        BufferedImage imagen = null;
        try
        {
            imagen = ImageIO.read(new File("res\\casilla" + numCasilla + ".png"));
        }
        catch(IOException ioe) {}
        
        // Imagen resultante
        ImageIcon icono = new ImageIcon();
        {
            // Creamos una imagen temporal en memoria
            BufferedImage bi = new BufferedImage(90, 90, BufferedImage.TYPE_INT_ARGB);
            Graphics2D g2 = bi.createGraphics();

            // Definimos la transformacin
            double angulo = Math.toRadians(grados);
            double x = (90 - imagen.getWidth())/2;
            double y = (90 - imagen.getHeight())/2;
            AffineTransform at = AffineTransform.getTranslateInstance(x,y);
            at.rotate(angulo, imagen.getWidth()/2, imagen.getHeight()/2);
            
            // Dibujamos la imagen original con la transformacin en la temporal
            g2.drawRenderedImage(imagen, at);
            
            // Liberamos la memoria usada
            g2.dispose();
            
            // Devolvemos la imagen rotada
            icono = new ImageIcon(bi);
        }

        return icono;
    }
    
}
